;; Copyright (c) 2006-2015 Carlos Ungil

(in-package :rcl)

(defvar *use-quartz* t 
  "On MacOSX open Quartz windows by default, instead of using X11")

;; May be required in MacOSX if there are issues with fonts in X11
;;  export LC_CTYPE=en_US.UTF-8
;;  export LC_ALL=en_US.UTF-8

(defun process-events ()
  (with-float-traps-masked
      #-windows (r-runhandlers *r-inputhandlers* (r-checkactivity 0 1))
      #+(or :windows :macosx :darwin) (with-float-traps-masked (r-processevents))))

(defvar *event-loop* nil)

(defun event-loop ()
  (bt:make-thread
   (lambda ()
     (loop do (bt:interrupt-thread *r-thread* #'process-events)
	  (process-events)
	  (sleep 0.1)))
   :name "event loop"))
  
(defun x11 (&optional (quartz #+(or :macosx :darwin) *use-quartz*))
  (ensure-r)
  (r (if quartz "quartz" "x11"))
  (unless (and *event-loop* (bt:thread-alive-p *event-loop*))
    (setf *event-loop* (event-loop))))

